$title	Run some consistency tests for aggregate datasets.

*	NB: Benchmark consistency is a necessary, but not a
*	sufficient condition that the model is properly specified.


*	Run BENCHMARK checks for the g20_macro dataset in both MGE
*	and MCP formats.  This routine produces a replication check
*	for the GMR model and all the single region SOE  models:

$set ds g20_macro
$call start "bmkchk_mge" gams bmkchk --mdl=mge --ds=%ds% o=bmkchk_mge.lst
$call gams bmkchk --mdl=mcp --ds=%ds% o=bmkchk_mcp.lst

*	Next we perform a check of consistency for the MCP and 
*	MGE models at a counterfactual point.

$log	Solve the MGE model then verify that the solution is
$log	valid for the MCP model for the g20 dataset

$label mcpmge
$set ds g20
$if exist gtap9_p.gdx $call del gtap9_p.gdx
$call gams mcpmge --mdl=mge --ds=%ds% gdx=mge1_%ds% o=mge1_%ds%.lst ps=0
$call gams mcpmge --mdl=mcp --ds=%ds% gdx=mcp1_%ds% o=mcp1_%ds%.lst ps=0

$log	Then solve the MCP model then verify that the solution is
$log	valid for the MGE model:

$if exist gtap9_p.gdx $call del gtap9_p.gdx
$call gams mcpmge --mdl=mcp --ds=%ds% gdx=mcp2_%ds% o=mcp2_%ds%.lst ps=0
$call gams mcpmge --mdl=mge --ds=%ds% gdx=mge2_%ds% o=mge2_%ds%.lst ps=0

*	Finally, verify that the CDE demand system reproduces the
*	exogenous own-price and income demand elasticities:

$label cdechk

$set ds g20
$call gams cdechk --ds=%ds%
