*	Declare some macros to move between model types:

$macro loaddsys(ff,r) \
	if (sameas(ff,"les"), loadles(r); ); \
	if (sameas(ff,"cd"),   loadcd(r); ); \
	if (sameas(ff,"cde"), loadcde(r); ); 
	
$macro loadles(r)  \
	loadcd(r); \
	les(r) = yes; \
	esub("sd",r) = 0; \
	esub("dd",r) = 1; \
	rtfd(i,lesd,r) = rtfd(i,"c",r); \
	rtfi(i,lesd,r) = rtfi(i,"c",r); \
	vdfm(i,"sd",r) = vdfm(i,"c",r)*(1-betales(r)*eta(i,r)); \
	vifm(i,"sd",r) = vifm(i,"c",r)*(1-betales(r)*eta(i,r)); \
	vdfm(i,"dd",r) = vdfm(i,"c",r)*betales(r)*eta(i,r); \
	vifm(i,"dd",r) = vifm(i,"c",r)*betales(r)*eta(i,r); \
	vom(lesd,r) = sum(i,vdfm(i,lesd,r)*(1+rtfd(i,lesd,r)) +  \
			    vifm(i,lesd,r)*(1+rtfi(i,lesd,r))); \
	vom("c",r) = 0;

$macro	loadcde(r) \
	loadcd(r); \
	cde(r) = yes; \
	vcm(i,r) = vdfm(i,"c",r)*(1+rtfd(i,"c",r)) + vifm(i,"c",r)*(1+rtfi(i,"c",r)); \
	vom(cd,r) = 0; \
	U.L(r) = 1; \
	D.L(i,r)$vcm(i,r) = 1; \
	CC.L(r) = 1;

$macro loadcd(r)  \
	unloadcde(r) \
	unloadles(r) 

$macro unloadles(r)  \
	rtfd(i,lesd,r) = 0; \
	rtfi(i,lesd,r) = 0; \
	vdfm(i,lesd,r) = 0; \
	vifm(i,lesd,r) = 0; \
	vom("c",les(r)) = sum(i,vdfm(i,"c",r)*(1+rtfd(i,"c",r)) +  \
			    vifm(i,"c",r)*(1+rtfi(i,"c",r))); \
	vom(lesd,les(r)) = 0; \
	les(r) = no;

$macro unloadcde(r) \
	vom("c",cde(r)) = sum(i,vdfm(i,"c",r)*(1+rtfd(i,"c",r)) +  \
			    vifm(i,"c",r)*(1+rtfi(i,"c",r))); \
	vcm(i,cde(r)) = 0; \
	U.L(cde(r)) = 0; \
	D.L(i,cde(r)) = 0; \
	CC.L(cde(r)) = 0; \ 
	cde(r) = no;

*.$if defined r_  $abort "The loadrm(r) macro requires a uniquely defined alias for r."
$if defined ii_ $abort "The loadrm(r) macro requires a uniquely defined alias for i."
*.$if defined j_  $abort "The loadrm(r) macro requires a uniquely defined alias for j."
$if defined ss_ $abort "The loadrm(r) macro requires a uniquely defined alias for s."

alias (r,r_,rr), (j,j_),(i,ii_), (s,ss_), (f,f_);

$macro loadrm(r) \
	rm(r_) = no; \
	rm(r) = yes; \
	rnum(r) = yes$(rm(r) and (vom("c",r)+vom("sd",r)+vom("dd",r)= \
			  smax(rm,vom("c",rm)+vom("sd",rm)+vom("dd",rm)))); \
	rx(r_) = (not rm(r_)); \
	vem(ii_,r_) = sum(rx,vxmd(ii_,r_,rx))$rm(r_) + sum(rm,vxmd(ii_,r_,rm))$rx(r_); \
	vem(ii_,r_)$(not round(vem(ii_,r_),5)) = 0; \
	rtxs_row(ii_,r_) = (sum(rx,vxmd(ii_,r_,rx)*rtxs(ii_,r_,rx))/vem(ii_,r_))$(rm(r_) and vem(ii_,r_));\
	rowpfx = sum(rx, vom("c",rx)+vom("sd",rx)+vom("dd",rx)+ \
		 sum(ii_,vcm(ii_,rx))+sum((j_,ii_,ss_),vtwr(j_,ii_,ss_,rx))) + sum(rm,vb(rm));\
	pem0(ii_,r_) = (1-rtxs_row(ii_,r_))$rm(r_);
